' Script need to have for run a packet with check_* and ofc send_nsca for win32
' (i'm using checks from http://nagiospluginsnt.getproactivenow.com/doku.php )
' beware: I cannot make the performance data to send, someone can help with this?
' v 0.0.1.0a (c) 2006-10-25 * fixed little bug with strCHKDIR
' 							+ added sleep_time parameter to pause script for a while
' Copyright (c) 2006 by orzeh <orz3h (at) tlen (dot) pl> 
' Distributed under the GPLv2 or newer (except for the unknown INI-functions)
'
' this version uses the ini (script assume exist the ini in the same folder) file for checks and for config, 
' if no [CONFIG] section is found the default settings are used
' the ini file as is (only example, fill those settings with your data):
' 
' [CONFIG]
' check_dir=c:\nsca\checks\
' nsca_exe=c:\nsca\send_nsca.exe
' nsca_cfg=c:\nsca\send_nsca.cfg
' nsca_port=5667
' nsca_host=10.0.0.1
' nsca_delimiter=;
' sleep_time=1000
'
' [nagioshost1]
' IP=1.2.3.4
' sensor=name of service in nagios
' command=check_* command eg. check_ping
' parameters=parameters for command
'
' [nagioshost2]
' IP=5.6.7.8
' sensor=name of service in nagios
' command=check_* command eg. check_ping
'
' [nagioshostn]
' IP=0.9.8.7
' sensor=name of service in nagios
' command=check_* command eg. check_ping
'
'
'


On Error Resume Next
' ini-file
file = "C:\nsca\checks\check_nsca.ini"

' checks command
strCHKDIR = GetINIString("CONFIG", "check_dir", "c:\nsca\checks\", file)

' nsca prog
strCMDNSCA = GetINIString("CONFIG", "nsca_exe", "send_nsca.exe", file)
strCFGNSCA = GetINIString("CONFIG", "nsca_cfg", "send_nsca.cfg", file)
strPRTNSCA = GetINIString("CONFIG", "nsca_port", "5667", file)
' delimiter of command instead tabs
strDLMNSCA = GetINIString("CONFIG", "nsca_delimiter", ";", file)

' Host with nsca service
strNSCAHst = GetINIString("CONFIG", "nsca_host", "10.0.0.254", file)

' Sleep time for script in ms
intSLEEP = GetINIString("CONFIG", "sleep_time", "1000", file)

' for all sections in ini file

Set objShell = CreateObject("WScript.Shell")
Dim FI: Set FI = CreateObject("Scripting.FileSystemObject")
dim sec1: set sec1 = FI.OpenTextFile(file)
Do While sec1.AtEndOfStream <> true
linein = sec1.ReadLine
if len(linein) > 0 then
'wscript.echo linein
if left(linein,1) = "[" and left(linein,8) <> "[CONFIG]" then
PosSection = InStr(1, linein, "[")
PosEndSection = InStr(PosSection, linein, "]")
sContents = Mid(linein, PosSection+1, PosEndSection - PosSection -1)


IP = GetINIString(scontents, "IP", "none", file)
strSensor = GetINIString(scontents, "sensor", "", file)
strCHKCMD = GetINIString(scontents, "command", "", file)
strParameters= GetINIString(scontents, "parameters", "", file)

strCommand = "%comspec% /c " & strCHKDIR &""& strCHKCMD & " -H "& IP &" "& strParameters

'wscript.echo strCommand

Set objExecObject = objShell.Exec(strCommand)

Do While objExecObject.Status = 0
	Wscript.Sleep(100)
Loop

'przejecie danych

	strOut = objExecObject.StdOut.ReadAll
	strErr = objExecObject.ExitCode


poz = InStr(StrOut,"|")
out = Left(StrOut,poz-1)

strWynik = strErr &";"& out

strNSCA = "%comspec% /c echo " & scontents & ";" & strSensor & ";" & strWynik  &" | "& strCMDNSCA & " -H " & strNSCAHst &" -p "& strPRTNSCA & " -c " & strCFGNSCA & " -d " & strDLMNSCA

'wscript.echo strNSCA

Set objExec = objShell.Exec(strNSCA)

Wscript.Sleep(intSLEEP)

end if
end if

Loop

' here are some functions from net
' http://www.motobit.com/tips/detpg_asp-vbs-read-write-ini-files/
' i cannot find the license for them

Function GetINIString(Section, KeyName, Default, FileName)
  Dim INIContents, PosSection, PosEndSection, sContents, Value, Found
    
  INIContents = GetFile(FileName)
 
  PosSection = InStr(1, INIContents, "[" & Section & "]", vbTextCompare)
  If PosSection>0 Then
    PosEndSection = InStr(PosSection, INIContents, vbCrLf & "[")
    If PosEndSection = 0 Then PosEndSection = Len(INIContents)+1

    sContents = Mid(INIContents, PosSection, PosEndSection - PosSection)

    If InStr(1, sContents, vbCrLf & KeyName & "=", vbTextCompare)>0 Then
      Found = True
      Value = SeparateField(sContents, vbCrLf & KeyName & "=", vbCrLf)
    End If
  End If
  If isempty(Found) Then Value = Default
  GetINIString = Value
End Function

Function SeparateField(ByVal sFrom, ByVal sStart, ByVal sEnd)
  Dim PosB: PosB = InStr(1, sFrom, sStart, 1)
  If PosB > 0 Then
    PosB = PosB + Len(sStart)
    Dim PosE: PosE = InStr(PosB, sFrom, sEnd, 1)
    If PosE = 0 Then PosE = InStr(PosB, sFrom, vbCrLf, 1)
    If PosE = 0 Then PosE = Len(sFrom) + 1
    SeparateField = Mid(sFrom, PosB, PosE - PosB)
  End If
End Function

Function GetFile(ByVal FileName)
Dim FS: Set FS = CreateObject("Scripting.FileSystemObject")
    GetFile = FS.OpenTextFile(FileName).ReadAll
End Function

